static int hash9812exp(name) char *name;
{int d = 0, dj, s[8], e=0;
 int i, j, len=strlen(name);
 char *pn = name;
 if(len==0){return(0);};
 for (j = 0; j < 8; ++j) {s[j] = 0;};
 for (i = 0; i < len; ++i)
   {dj = (d = (unsigned char)(* pn));
    ++pn;
    for (j = 0; j < 8; ++j)
      {s[j] += dj; dj = dj * d;};};
 for (j = 7; j >= 0; --j)
   {e = (e << 8) | (s[j] & 0xff);};
 if(e < 0){e = -e;};
 return(e);}

static int hash9812_64(name) char *name;
{int d = 0, a, s[8], e=0;
 int i, j, len=strlen(name);
 char *pn = name;
 if(len==0){return(0);};
 for (j = 0; j < 8; ++j) {s[j] = 0;};
 for (i = 0; i < len; ++i)
   {d = (unsigned char)(* pn);
    a = 1;
    for (j = 0; j < 8; ++j)
      {s[j] += a * d; a = a * i;};
    ++pn;};
 /*
 for (j = 7; j >= 0; --j)
   {printf ("s[%d] & 0xff = %2x\n", j, (s[j] & 0xff));};
 */
 for (j = 7; j >= 0; --j)
   {e = (e << 8) | (s[j] & 0xff);
    /* printf ("e = %x\n", e); */};
 /* printf ("e = %x -e = %x\n", e, -e); */
 if(e < 0) {if((e = -e) < 0) {e = 0;};};
 return(e);}

static int hash9812_32(name) char *name;
{int d = 0, a, s[4], e=0;
 int i, j, len=strlen(name);
 char *pn = name;
 if(len==0){return(0);};
 for (j = 0; j < 4; ++j) {s[j] = 0;};
 for (i = 0; i < len; ++i)
   {d = (unsigned char)(* pn);
    a = 1;
    for (j = 0; j < 4; ++j)
      {s[j] += a * d; a = a * i;};
    ++pn;};
 /*for (j = 3; j >= 0; --j)
   {printf ("s[%d] & 0xff = %2x\n", j, (s[j] & 0xff));}; */
 for (j = 3; j >= 0; --j)
   {e = (e << 8) | (s[j] & 0xff);
    /* printf ("e = %x\n", e); */};
 /* printf ("e = %x -e = %x\n", e, -e); */
 if(e < 0) {if((e = -e) < 0) {e = 0;};};
 return(e);}
