#!/bin/sh

JMORPH_TYPE="$1"
JMORPH="$2"
SEP="$3"

if   [ "M${JMORPH_TYPE}" = "Mchasen" ]; then

"${JMORPH}" -F "%M\t%H\n" |\
jperl -nle '($stm, $pos) = split (/\t/);
  if (qq($stm) eq qq('"$SEP"')) {print qq($stm);}
  elsif (($pos =~ /^(̾|ư|ƻ|̤θ|)/) &&
         ($stm =~ /^[0-9A-Za-z--]/) &&
         ($stm !~ /^[-]{1,2}$/)) {print qq($stm);};'

elif   [ "M${JMORPH_TYPE}" = "Mjuman" ]; then

"${JMORPH}" -e |\
jperl -anle '($stm, $pos) = (@F[2,3]);
  if (qq($stm) eq qq('"$SEP"')) {print qq($stm);}
  elsif (($pos =~ /^(̾|ư|ƻ|̤)/) &&
         ($stm =~ /^[0-9A-Za-z--]/) &&
         ($stm !~ /^[-]{1,2}$/)) {print qq($stm);};'

elif   [ "M${JMORPH_TYPE}" = "Manima" ]; then

"${JMORPH}" |\
jperl -anle '($stm, $pos) = (@F[1,2]);
  if (qq($stm) eq qq('"$SEP"')) {print qq($stm);}
  elsif (($pos =~ /^(̾|ư|ƻ|̤Ͽ)/) &&
         ($stm =~ /^[0-9A-Za-z--]/) &&
         ($stm !~ /^[-]{1,2}$/)) {print qq($stm);};'

elif   [ "M${JMORPH_TYPE}" = "Mfanima" ]; then

"${JMORPH}" |\
jperl -anle 'print qq(@F[1]);'

fi
