#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <HTB9707a.h>

int Fdebug=0;

/* hasize: hashsize
   hbsize: character buffer size
   ht0size: initial itemsize
   htdsize: incremental itemsize
*/

struct HTB9707
*htbgen (hasize, hbsize, ht0size, htdsize, datasize)
int hasize, hbsize, ht0size, htdsize, datasize;
{int i;
 struct HTB9707 *ph;
 if(datasize < 0){datasize=0;};
 if(!(ph=(struct HTB9707 *)calloc(sizeof(struct HTB9707),1)))
   {return(NULL);};
 ph->hasize=hasize;
 ph->hbsize=hbsize;
 ph->htsize=ht0size;
 ph->htdsize=htdsize;
 ph->datasize=datasize;
 if(!((ph->ha)=(int *)calloc(sizeof(int),hasize))){return(NULL);};
 if(!((ph->ht)=(char **)calloc(sizeof(char *),ht0size))){return(NULL);};
 if(!((ph->htn)=(int *)calloc(sizeof(int),ht0size))){return(NULL);};
 if(!((ph->hb0)=(char *)calloc(sizeof(char),hbsize))){return(NULL);};
 if(!((ph->dataIdx)=(void **)calloc(sizeof(char *),ht0size))){return(NULL);};
 if(datasize>0)
   {if(!((ph->data0)=(void *)calloc(datasize,ht0size))){return(NULL);};}
 else{(ph->data0)=(void *)ph;};
 init_htb(ph);
 return(ph);}

init_htb(phtb) struct HTB9707 *phtb;
{int i, hasize=phtb->hasize;
 for(i=0;i<hasize;++i){*((phtb->ha)+i)=-1;};
 phtb->iht=0;
 phtb->ihb=0;
 phtb->hb=phtb->hb0;
 phtb->data=phtb->data0;
 return(0);}

int htbn(ph) struct HTB9707 *ph; {return(ph->iht);}

char *htbi2h(i,ph) int i; struct HTB9707 *ph;
{return(*((ph->ht)+i));}
void *htbi2d(i,ph) int i; struct HTB9707 *ph;
{return(*((ph->dataIdx)+i));}

int htbAi0(str,ph)
struct HTB9707 *ph; char *str;
{struct HTB9707R htb9707();
 return((htb9707(str,ph,hashD,1)).i);};
int htbi0(str,ph)
struct HTB9707 *ph; char *str;
{struct HTB9707R htb9707();
 return((htb9707(str,ph,hashD,0)).i);};
int htbAi(str,ph,hashf)
struct HTB9707 *ph; char *str; int (*hashf)();
{struct HTB9707R htb9707();
 return((htb9707(str,ph,hashf,1)).i);};
int htbi(str,ph,hashf)
struct HTB9707 *ph; char *str; int (*hashf)();
{struct HTB9707R htb9707();
 return((htb9707(str,ph,hashf,0)).i);};

char *htbAh0(str,ph)
struct HTB9707 *ph; char *str;
{struct HTB9707R htb9707();
 return((htb9707(str,ph,hashD,1)).h);};
char *htbh0(str,ph)
struct HTB9707 *ph; char *str;
{struct HTB9707R htb9707();
 return((htb9707(str,ph,hashD,0)).h);};
char *htbAh(str,ph,hashf)
struct HTB9707 *ph; char *str; int (*hashf)();
{struct HTB9707R htb9707();
 return((htb9707(str,ph,hashf,1)).h);};
char *htbh(str,ph,hashf)
struct HTB9707 *ph; char *str; int (*hashf)();
{struct HTB9707R htb9707();
 return((htb9707(str,ph,hashf,0)).h);};

void *htbAd0(str,ph)
struct HTB9707 *ph; char *str;
{struct HTB9707R htb9707();
 return((htb9707(str,ph,hashD,1)).d);};
void *htbd0(str,ph)
struct HTB9707 *ph; char *str;
{struct HTB9707R htb9707();
 return((htb9707(str,ph,hashD,0)).d);};
void *htbAd(str,ph,hashf)
struct HTB9707 *ph; char *str; int (*hashf)();
{struct HTB9707R htb9707();
 return((htb9707(str,ph,hashf,1)).d);};
void *htbd(str,ph,hashf)
struct HTB9707 *ph; char *str; int (*hashf)();
{struct HTB9707R htb9707();
 return((htb9707(str,ph,hashf,0)).d);};

struct HTB9707R htb9707(str,ph,hashf,Fadd)
char *str;
struct HTB9707 *ph;
int (*hashf)();
int Fadd;
{char *name="HTB9707";
 int *ha=ph->ha;
 char **ht=ph->ht;
 int *htn=ph->htn;
 char *hb=ph->hb;
 void **dataIdx=ph->dataIdx;
 void *data=ph->data;
 int hasize=ph->hasize;
 int hbsize=ph->hbsize;
 int htsize=ph->htsize;
 int htdsize=ph->htdsize;
 int datasize=ph->datasize;
 int IHT=ph->iht;
 int IHB=ph->ihb;
 int v=hashf(str)%hasize, iht, ihtp;
 int slen=strlen(str);
 extern int Fdebug;
 struct HTB9707R val;
 val.i=-1; val.h=NULL; val.d=NULL;
/* if((htbn(ph)>=19500)&&(htbn(ph)<20000)){Fdebug=1;} else{Fdebug=0;};*/
 if(Fdebug)
   {fprintf(stderr,"input: %s hash-value: %d %d\n", str, v, htbn(ph));
    if (v < 0)
      {fprintf(stderr,"Error %s. hash value v = %d < 0\n", name, v);
       return (val);};};
 if(slen>=hbsize)
   {hbsize=slen+1;
    if(!(hb=(char *)calloc(sizeof(char),hbsize))){return(val);};
    fprintf(stderr,"%s: %d bytes were additionally allocated.\n",
            name, slen+1);
    IHB=0;
    ph->hbsize=hbsize;};
 if((iht=ha[v])>=0)
   {if(Fdebug){fprintf(stderr,"--- hash hit: iht=%d\n", iht);};
    while(iht>=0)
      {/*if(Fdebug)
	 {fprintf(stderr, "---%d %s %d\n", 
                   iht, ht[iht], (int)(*(dataIdx+iht)));};*/
       if(!strcmp(ht[iht],str))
	 {val.h=ht[iht];
          val.d=dataIdx[iht];
          val.i=iht;
          return(val);};
       ihtp=iht;
       iht=htn[iht];};
    if(Fadd)
      {if(Fdebug){fprintf(stderr,"---A00\n");};
       if(IHT>=htsize)
	 {ph->htsize=htsize=htsize+(ph->htdsize);
          if(!((ph->ht)=ht=(char **)
               realloc(ph->ht,sizeof(char *)*htsize)))
	    {return(val);};
          if(!((ph->htn)=htn=(int *)realloc(ph->htn,sizeof(int)*htsize)))
	    {return(val);};
          if(!((ph->dataIdx)=dataIdx=
                 (void **)realloc(ph->dataIdx, sizeof(void *)*htsize)))
	    {return(val);};
          if(datasize>0)
	    {if(!((ph->data)=data=(void *)calloc(datasize,htdsize)))
	       {return(val);};};
          fprintf(stderr,"%s: htsize changed to %d\n",
                  name, htsize);};
       htn[ihtp]=iht=IHT;
       htn[iht]=-1;
       ++(ph->iht);
       if((IHB+slen+1)>=hbsize)
	 {if(!(hb=(char *)calloc(sizeof(char),ph->hbsize)))
	    {return(val);};
          fprintf(stderr,"%s: %d bytes were additionally allocated.\n",
                  name, hbsize);
          IHB=0;};
       strcpy(hb,str);
       ht[iht]=hb;
       ph->hb=hb+slen+1;
       ph->ihb=IHB+strlen(str)+1;
       *(dataIdx+iht)=data;
       (ph->data)=(void *)((char *)(ph->data)+datasize);
       val.h=ht[iht];
       val.d=dataIdx[iht];
       val.i=iht;
       return(val);}
    else{return(val);};}
 else
   {if(Fadd)
      {if(Fdebug){fprintf(stderr,"---B00\n");};
       if(IHT>=htsize)
	 {ph->htsize=htsize=htsize+(ph->htdsize);
          if(!(ht=(char **)realloc(ph->ht,sizeof(char *)*htsize)))
	    {return(val);};
          ph->ht=ht;
          if(!((ph->htn)=htn=(int *)realloc(ph->htn,sizeof(int)*htsize)))
	    {return(val);};
          if(!((ph->dataIdx)=dataIdx=
                 (void **)realloc(ph->dataIdx, sizeof(void *)*htsize)))
	    {return(val);};
          if(datasize>0)
	    {if(!((ph->data)=data=(void *)calloc(datasize,htdsize)))
	       {return(val);};};
          fprintf(stderr,"%s: htsize changed to %d\n", name, htsize);
          };
       ha[v]=iht=IHT;
       htn[iht]=-1;
       ++(ph->iht);
       if((IHB+slen+1)>=hbsize)
	 {if(!(hb=(char *)calloc(sizeof(char),ph->hbsize))){return(val);};
          fprintf(stderr,"%s: %d bytes were additionally allocated.\n",
                  name, hbsize);
          IHB=0;};
       strcpy(hb,str);
       ht[iht]=hb;
       ph->hb=hb+slen+1;
       ph->ihb=IHB+slen+1;
       *(dataIdx+iht)=data;
       (ph->data)=(void *)((char *)(ph->data)+datasize);
       val.h=ht[iht];
       val.d=dataIdx[iht];
       val.i=iht;
       return(val);}
    else{return(val);};};}

clear_htb(phtb, hashf) struct HTB9707 *phtb; int (*hashf)();
{int i, nhtb=htbn(phtb);
 int hasize = phtb -> hasize;
 for(i = 0; i < nhtb; ++i)
   {*((phtb->ha) + (hashf(htbi2h(i, phtb)) % hasize)) = -1;};
 phtb->iht=0;
 phtb->ihb=0;
 phtb->hb=phtb->hb0;
 phtb->data=phtb->data0;
 return(0);}

dump_htb(phtb, fp) struct HTB9707 *phtb; FILE *fp;
{int i, f;
 int hasize = phtb -> hasize;
 for(i = 0; i < hasize; ++i)
   {f = dup_htb(i, phtb);
    if (f)
      {fprintf(fp, "%d %d %s\n", f, i, htbi2h(*((phtb->ha) + i), phtb));};};
 return(0);};

stat_htb(phtb, fp) struct HTB9707 *phtb; FILE *fp;
{int i, f;
 int max_dup = 0, c_used=0;
 int hasize = phtb -> hasize;
 fprintf(fp, "HTB9707a item number: %d\n", htbn(phtb));
 for(i = 0; i < hasize; ++i)
   {f = dup_htb(i, phtb);
    if (f) {++ c_used;
	    if (f > max_dup) {max_dup = f;};};};
 if (hasize > 0)
   {fprintf(fp, "HTB9707a hash-size: %d used: %d (%.1f %c)\n",
	    hasize, c_used, (100.0 * c_used / hasize), '%');
    fprintf(fp, "HTB9707a max_dup: %d\n", max_dup);};
 return(0);};

int dup_htb(i, phtb) int i; struct HTB9707 *phtb;
{int n=*((phtb->ha) + i), f=0;
 while (n >= 0)
   {++f;
    n = next_htb(n, phtb);};
 return(f);}

int next_htb(i, phtb) int i; struct HTB9707 *phtb;
{return (*((phtb -> htn) + i));}
