#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <HTB9707a.h>
#include <hash9812.h>
#define USIZE 1000000

#define MLINEL  10002

long int *F[USIZE];
char     *H[USIZE];
int FI;

htb9707i_x(str,ph,hashF,p)
char *str; struct HTB9707 *ph; char *hashF; int p; {
  if (strcmp(hashF,"hashD")) {
    return (htb9707(str,ph,hashD,p).i);}
  else if (strcmp(hashF,"hash9812exp")) {
    return (htb9707(str,ph,hash9812exp,p).i);}
  else if (strcmp(hashF,"hash9812_64")) {
    return (htb9707(str,ph,hash9812_64,p).i);}
  else if (strcmp(hashF,"hash9812_32")) {
    return (htb9707(str,ph,hash9812_32,p).i);}
  else return(-1);};

main(argc, argv) int argc; char *argv[];
{char *name="freq-per-unit";
 char *usage="freq-per-unit <separator> -hashF <hashF> -init_per <init-htb-per>";
 char line[MLINEL];
 int linelen;
 long int cline=0;
 /*---------------*/
 long int *fq; int wn;
 char *separator=argv[1];
 int seplen=strlen(separator);
 struct HTB9707 *phtb;
 long int nhtb, i;
 long int cunit=0; int cunit1=0;
 char *hashF = "hashD"; 
 int hasize=1000000, hbsize=10000000, ht0size=1000000, htdsize=1000000;
 int init_per=0;
 /*---------------*/
 if(argc < 2){fprintf(stderr,"usage: %s\n", usage); return(-1);};
 {int i = 1;
  while (++i < argc) {
    if (! strcmp(argv[i],"-hashF")) {
      if (++i < argc) {hashF = argv[i];}
      else {fprintf(stderr,"usage: %s\n", usage); return(-1);};}
    else if(!strcmp(argv[i],"-init_per")) {
      if(++i<argc){init_per=atoi(argv[i]);}
      else {fprintf(stderr,"usage: %s\n", usage); return(-1);};}
    else if(!strcmp(argv[i],"-hasize")) {
      if(++i<argc){hasize=atoi(argv[i]);}
      else {fprintf(stderr,"usage: %s\n", usage); return(-1);};}
    else if(!strcmp(argv[i],"-hbsize")) {
      if(++i<argc){hbsize=atoi(argv[i]);}
      else {fprintf(stderr,"usage: %s\n", usage); return(-1);};}
    else if(!strcmp(argv[i],"-ht0size")) {
      if(++i<argc){ht0size=atoi(argv[i]);}
      else {fprintf(stderr,"usage: %s\n", usage); return(-1);};}
    else if(!strcmp(argv[i],"-htdsize")) {
      if(++i<argc){htdsize=atoi(argv[i]);}
      else {fprintf(stderr,"usage: %s\n", usage); return(-1);};}
    else {fprintf(stderr,"usage: %s\n", usage); return(-1);};};}
 if (! separator) {
   fprintf (stderr, "Error %s, %s can not be compiled.\n",
	    name, separator);
   return(-1);};
 if(!(phtb=htbgen(hasize, hbsize, ht0size, htdsize, sizeof(long int))))
   {fprintf(stderr,"Error %s, htbG gen. fiailed.\n", name);
    return(-1);};
 /*---------------*/
 line[MLINEL-2]='\0';
 FI = 0;
 while(fgets(line,MLINEL,stdin)!=NULL)
   {++cline;
    if(line[MLINEL-2]!='\0')
      {fprintf(stderr,"Error %s, line %d too long.\n", name, cline);
       line[50]='\0';
       fprintf(stderr,"  %s:\n", line);
       return(-1);};
    if((linelen=strlen(line))){line[linelen-1]='\0';};
    /*---------------------------*/
    if (! strncmp (separator, line, seplen)) {
      for(i=0; i < FI; ++i) {
	printf("%ld %s\n", *F[i], H[i]);
	*F[i] = 0;};
      FI = 0;
      puts(line);
      ++cunit;
      if ((init_per > 0) && (cunit % init_per == 0)) {init_htb(phtb);};
      if((++cunit1) == 1000) {
	/* fprintf(stderr,"%s: #unit: %d\n", name, cunit);*/
	cunit1=0;};}
    else {
      if ((wn = htb9707i_x(line,phtb,hashF,0)) >= 0) {
	fq = htbi2d(wn,phtb);
	if (! *fq) {
	  if (FI < USIZE) {
	    F[FI] = fq; H[FI] = htbi2h(wn,phtb);
	    ++ FI;}
	  else {fprintf (stderr, "Error %s, size over.\n", name);
		return(-1);};};
	++ *fq;}
      else if ((wn = htb9707i_x(line,phtb,hashF,1)) >= 0) {
	fq = htbi2d(wn,phtb);
	if (FI < USIZE) {
	  F[FI] = fq; H[FI] = htbi2h(wn,phtb);
	  ++ FI;
	*fq = 1;}
	else {fprintf (stderr, "Error %s, size over.\n", name);
	      return(-1);};}
      else {fprintf (stderr, "Error %s, memory shortage.\n", name);
	    return(-1);};
    };
  };
 /*---------------------------*/
 for(i=0; i < FI; ++i) {
   printf("%ld %s\n", *F[i], H[i]);
   *F[i] = 0;};
 FI = 0;
 /*---------------------------*/
 fprintf(stderr,"%s: #unit: %d\n", name, cunit);
 return(0);}
