#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MCOML    1002
#define MLINEL  20002

/* <path-name> <seek> <bytes> <ln>*/

main(argc,argv) int argc; char *argv[];
{char path_name[MCOML], pfn[MCOML], *filename;
 char *name="ret-texts";
 char *usage="ret-texts <DD> {<header-format>}";
 FILE *fin = NULL;
 char line[MLINEL];
 int  linelen;
 char c;
 long int sk; int bt, tbt, ln, tln;
 /*----------*/
 int Fh = 0;
 char *dd=argv[1];
 char *header=argv[2];
 char com[MLINEL], *words[10];
 int  comlen, wc;
 int  nfopen=0;
 /*----------*/
 if (argc == 3) {Fh = 1;}
 else if (argc != 2) {fprintf (stderr, "usage: %s\n", usage); return(-1);};
 /*----------*/
 com[MCOML-2]='\0';
 pfn[0]='\0';
 while(fgets(com,MCOML,stdin)!=NULL) {
   if(com[MCOML-2]!='\0') {
     fprintf(stderr,"Error %s, too long.\n", name);
     com[50]='\0'; fprintf(stderr,"  %s:\n", com); return(-1);};
   if ((comlen = strlen(com) - 1) >= 0) {com[comlen] = '\0';};
   if(Fh) {printf(header,com); putchar('\n');};
   if ((wc=dsplit_by_sp(com,words,7)) >= 4){
     filename = words[0];
     sprintf(path_name,"%s/%s",dd,filename);
     sk = atol(words[1]);
     tbt = atoi(words[2]);
     tln = atoi(words[3]);
     if (! fin || !pfn[0] || strcmp(pfn,filename)) {
       if (fin) {fclose(fin);};
       ++ nfopen;
       if (! (fin = fopen(path_name, "r"))) {
	 fprintf(stderr,"Error %s, %s cannot be opened (nfopen = %d).\n",
		 name, path_name, nfopen);
	 return(-1);};
       strcpy(pfn,filename);};
     fseek (fin, sk, 0);
     line[MLINEL-2]='\0';
     ln = 0; bt = 0;
     while((fgets(line,MLINEL,fin)!=NULL) && (ln < tln)) {
       if(line[MLINEL-2]!='\0') {
	 fprintf(stderr,"Error %s, too long.\n", name);
	 line[50]='\0'; fprintf(stderr,"  %s:\n", line); return(-1);};
       bt += (linelen = strlen(line));
       line[linelen-1]='\0';
       puts(line);
       ++ ln;};
     if ((ln != tln) || (bt != tbt)) {
       fprintf (stderr, "Error, %s ln = %d, tln = %d, bt = %d, tbt = %d\n",
		name, ln, tln, bt, tbt);
       return(-1);};}
   else {
     fprintf (stderr, "Error %s, irregal com line %s.\n", name, com);};};
 if (fin) {fclose(fin);};
 return(0);}

dsplit_by_sp(pl,args,n) unsigned char *pl, *args[]; int n;
{int argc=0;
 while((*pl!='\0')&&(*pl!='\n')&&(argc<n))
   {while(isspace(*pl)){++pl;};
    if((*pl=='\0')||(*pl=='\n')){break;};
    args[argc++]=pl;
    while((! isspace(*pl))&&(*pl!='\0')){++pl;};
    if(*pl!='\0'){*pl='\0';++pl;};};
 return(argc);}
